Subject: Re: [Infrahip] [PATCH] Host Identity Protocol

From: "David S. Miller" <[email-masked]>
Date: Tue, 22 Mar 2005 09:20:02 -0800

On Tue, 22 Mar 2005 16:08:31 +0200 (EET)
Miika Komu <[email-masked]> wrote:

> Yes, MIP6 and IKE signalling is handled in the userspace, but
> the same is not true for SCTP (lksctp).

SCTP is a network protocol used for data transfer.

HIP is a signalling mechanism used to setup configuration.

> engineering practise is to put everything in the userspace, unless there
> is good reason for putting it in to the kernelspace.
> 
> We don't currently have concrete measurements (comparing userspace and
> kernelspace approaches) to justify our kernel oriented approach, so we
> will have to get back to you later with some figures. If the results show
> that an userspace implementation is superior to a kernel based approach in
> terms of security or performance, we may have rewrite the code to the
> userspace. In the mean time, do you happen to know any good references
> where any userspace network protocol implementation has been compared and
> measured against a kernelspace implementation? It would be a good starting
> point for us.
> 
> I would like to mention that lksctp was implemented in the 2.6 kernel
> because of better performance and tighter integration to the socket API.
> We are dealing with similar issues with HIPL but seems like we need to
> justify the reasons by analyzing and measuring. In addition, security
> issues (DoS protection, user supplied public keys, etc) are taken pretty
> seriously in HIP and may benefit from a kernel oriented approach.
> 
> -- 
> Miika Komu              [email-masked]          http://www.iki.fi/miika/